import { Program, Type } from '@typespec/compiler';
import { ReactNode } from 'react';
export interface TypeGraphNodeBase {
    readonly id: string;
    readonly name: string;
    readonly children: TypeGraphNode[];
}
export interface TypeGraphTypeNode extends TypeGraphNodeBase {
    readonly kind: "type";
    readonly type: Type;
}
export interface TypeGraphListNode extends TypeGraphNodeBase {
    readonly kind: "list";
}
export type TypeGraphNode = TypeGraphTypeNode | TypeGraphListNode;
export interface TreeNavigator {
    readonly selectedNode?: TypeGraphNode;
    readonly selectedPath: string;
    readonly selectPath: (path: string) => void;
    readonly navToType: (type: Type) => void;
    readonly tree: TypeGraphListNode;
}
export declare function useTreeNavigatorOptional(): TreeNavigator | undefined;
export declare function useTreeNavigator(): TreeNavigator;
export interface TypeGraphNavigatorProvider {
    program: Program;
    children: ReactNode;
}
export declare const TypeGraphNavigatorProvider: ({ program, children }: TypeGraphNavigatorProvider) => import("react/jsx-runtime").JSX.Element;
//# sourceMappingURL=use-tree-navigation.d.ts.map